// Service worker for Offline Web IDE
const VERSION = 'v2';

const CACHED_RESOURCES = [
  'EspruinoTools/index.js',
  'EspruinoTools/espruino.js',
  'EspruinoTools/plugins/minify.js',
  'EspruinoTools/plugins/versionChecker.js',
  'EspruinoTools/plugins/boardJSON.js',
  'EspruinoTools/plugins/saveOnSend.js',
  'EspruinoTools/plugins/compiler.js',
  'EspruinoTools/plugins/assembler.js',
  'EspruinoTools/plugins/unicode.js',
  'EspruinoTools/plugins/localModules.js',
  'EspruinoTools/plugins/uiMode.js',
  'EspruinoTools/plugins/getGitHub.js',
  'EspruinoTools/plugins/npmModules.js',
  'EspruinoTools/plugins/setTime.js',
  'EspruinoTools/libs/esprima/escodegen.js',
  'EspruinoTools/libs/esprima/esmangle.js',
  'EspruinoTools/libs/esprima/esprima.js',
  'EspruinoTools/libs/targz.js',
  'EspruinoTools/libs/utf8.js',
  'EspruinoTools/bin/espruino-cli.js',
  'EspruinoTools/core/terminal.js',
  'EspruinoTools/core/serial_nodeserial.js',
  'EspruinoTools/core/config.js',
  'EspruinoTools/core/flasher.js',
  'EspruinoTools/core/codeWriter.js',
  'EspruinoTools/core/status.js',
  'EspruinoTools/core/notifications.js',
  'EspruinoTools/core/settingsAbout.js',
  'EspruinoTools/core/serial_chrome.js',
  'EspruinoTools/core/serial_audio.js',
  'EspruinoTools/core/env.js',
  'EspruinoTools/core/serial_socket.js',
  'EspruinoTools/core/modules.js',
  'EspruinoTools/core/utils.js',
  'EspruinoTools/core/serial_websocket.js',
  'EspruinoTools/core/serial.js',
  'EspruinoTools/core/serial_web_bluetooth.js',
  'blockly/blockly.html',
  'blockly/blockly_ble.js',
  'blockly/ru.js',
  'blockly/en.js',
  'blockly/blockly_robot.js',
  'blockly/blocks_compressed.js',
  'blockly/field_textarea.js',
  'blockly/javascript_compressed.js',
  'blockly/blockly_amperka_motorshield.js',
  'blockly/blockly_compressed.js',
  'blockly/blockly_espruino.js',
  'blockly/media/handclosed.cur',
  'blockly/media/tree.png',
  'blockly/media/trashlid.png',
  'blockly/media/1x1.gif',
  'blockly/media/delete.mp3',
  'blockly/media/trashbody.png',
  'blockly/media/delete.ogg',
  'blockly/media/anon.jpeg',
  'blockly/media/sprites.png',
  'blockly/media/handopen.cur',
  'blockly/media/quote1.png',
  'blockly/media/click.wav',
  'blockly/media/progress.gif',
  'blockly/media/quote0.png',
  'blockly/media/click.ogg',
  'blockly/media/delete.wav',
  'blockly/media/click.mp3',
  'js/plugins/fontSize.js',
  'js/plugins/testing.js',
  'js/plugins/urlHandler.js',
  'js/plugins/settingsProfile.js',
  'js/plugins/tern.js',
  'js/plugins/debugger.js',
  'js/plugins/project.js',
  'js/plugins/uiMode.js',
  'js/plugins/webcam.js',
  'js/plugins/codeLink.js',
  'js/plugins/fileReload.js',
  'js/plugins/tutorial.js',
  'js/plugins/watchExpression.js',
  'js/plugins/tour.js',
  'js/plugins/helpLinks.js',
  'js/plugins/arrows.js',
  'js/plugins/offline.js',
  'js/plugins/notification_sound.js',
  'js/libs/acorn/doc_comment.js',
  'js/libs/acorn/def.js',
  'js/libs/acorn/tern.js',
  'js/libs/acorn/acorn.js',
  'js/libs/acorn/acorn_loose.js',
  'js/libs/acorn/comment.js',
  'js/libs/acorn/infer.js',
  'js/libs/acorn/walk.js',
  'js/libs/acorn/signal.js',
  'js/libs/flot/jquery.flot.selection.js',
  'js/libs/flot/jquery.flot.js',
  'js/libs/flot/jquery.flot.time.js',
  'js/libs/jquery.sparkline.min.js',
  'js/libs/codemirror/javascript.js',
  'js/libs/codemirror/codemirror.js',
  'js/libs/codemirror/codemirror.css',
  'js/libs/codemirror/jshint.js',
  'js/libs/codemirror/addon/lint/json-lint.js',
  'js/libs/codemirror/addon/lint/css-lint.js',
  'js/libs/codemirror/addon/lint/coffeescript-lint.js',
  'js/libs/codemirror/addon/lint/lint.css',
  'js/libs/codemirror/addon/lint/javascript-lint.js',
  'js/libs/codemirror/addon/lint/lint.js',
  'js/libs/codemirror/addon/fold/comment-fold.js',
  'js/libs/codemirror/addon/fold/foldgutter.css',
  'js/libs/codemirror/addon/fold/xml-fold.js',
  'js/libs/codemirror/addon/fold/indent-fold.js',
  'js/libs/codemirror/addon/fold/foldcode.js',
  'js/libs/codemirror/addon/fold/foldgutter.js',
  'js/libs/codemirror/addon/fold/brace-fold.js',
  'js/libs/codemirror/addon/tern/tern.js',
  'js/libs/codemirror/addon/tern/tern.css',
  'js/libs/codemirror/addon/search/match-highlighter.js',
  'js/libs/codemirror/addon/search/searchcursor.js',
  'js/libs/codemirror/addon/search/search.js',
  'js/libs/codemirror/addon/edit/closebrackets.js',
  'js/libs/codemirror/addon/edit/matchbrackets.js',
  'js/libs/codemirror/addon/edit/continuelist.js',
  'js/libs/codemirror/addon/edit/trailingspace.js',
  'js/libs/codemirror/addon/edit/matchtags.js',
  'js/libs/codemirror/addon/edit/closetag.js',
  'js/libs/codemirror/addon/hint/show-hint.js',
  'js/libs/codemirror/addon/hint/show-hint.css',
  'js/libs/codemirror/addon/hint/javascript-hint.js',
  'js/libs/codemirror/addon/dialog/dialog.js',
  'js/libs/codemirror/addon/dialog/dialog.css',
  'js/libs/jquery.treeview.js',
  'js/libs/jquery-ui-1.10.1.custom.js',
  'js/libs/jquery-1.11.0.js',
  'js/libs/splitster/splitster.js',
  'js/libs/splitster/splitster.css',
  'js/libs/guiders/guiders.js',
  'js/libs/guiders/guiders.css',
  'js/libs/jcanvas/jcanvas.min.js',
  'js/libs/jszip.min.js',
  'js/libs/toastr/toastr.min.js',
  'js/libs/toastr/toastr.min.css',
  'js/libs/toastr/toastr.css',
  'js/core/editorBlockly.js',
  'js/core/send.js',
  'js/core/app.js',
  'js/core/status.js',
  'js/core/menuFlasher.js',
  'js/core/notifications.js',
  'js/core/settingsAbout.js',
  'js/core/menuSettings.js',
  'js/core/editorJavaScript.js',
  'js/core/settingsConsole.js',
  'js/core/file.js',
  'js/core/menuPortSelector.js',
  'js/core/settingsFlasher.js',
  'js/core/code.js',
  'js/background.js',
  'data/espruino.json',
  'data/app/openTestingLog.js',
  'data/app/openTestingLog.html',
  'data/testing_initial.html',
  'data/terminal_initial.html',
  'data/sounds/doorbell2.wav',
  'data/sounds/car_horn_x.wav',
  'data/sounds/sirens_x.wav',
  'data/sounds/honk2_x.wav',
  'data/sounds/toot2_x.wav',
  'data/sounds/boxing_bell.wav',
  'data/sounds/truck_horn.wav',
  'data/sounds/phone_ring_old.wav',
  'data/sounds/trolley2.wav',
  'data/sounds/warning_horn.wav',
  'data/sounds/chime_up.wav',
  'data/settings_flasher.html',
  'data/tours/projectSnippet.json',
  'data/tours/project.json',
  'data/tours/testingExt.json',
  'data/tours/testing.json',
  'data/tours/watchExpr.json',
  'data/tutorials/1.js',
  'data/testing_form.html',
  'data/settings_about.html',
  'data/testing_image.html',
  'css/reset.css',
  'css/typography.css',
  'css/main.css',
  'css/libs/tern.css',
  'css/libs/jquery.treeview.css',
  'css/abstracts.css',
  'css/ui-lightness/images/ui-bg_gloss-wave_35_f6a828_500x100.png',
  'css/ui-lightness/images/ui-bg_flat_10_000000_40x100.png',
  'css/ui-lightness/images/ui-bg_highlight-soft_100_eeeeee_1x100.png',
  'css/ui-lightness/images/ui-bg_diagonals-thick_20_666666_40x40.png',
  'css/ui-lightness/images/ui-bg_glass_100_fdf5ce_1x400.png',
  'css/ui-lightness/images/ui-icons_228ef1_256x240.png',
  'css/ui-lightness/images/ui-bg_diagonals-thick_18_b81900_40x40.png',
  'css/ui-lightness/images/animated-overlay.gif',
  'css/ui-lightness/images/ui-bg_highlight-soft_75_ffe45c_1x100.png',
  'css/ui-lightness/images/ui-icons_ffffff_256x240.png',
  'css/ui-lightness/images/ui-bg_glass_100_f6f6f6_1x400.png',
  'css/ui-lightness/images/ui-icons_ffd27a_256x240.png',
  'css/ui-lightness/images/ui-icons_ef8c08_256x240.png',
  'css/ui-lightness/images/ui-icons_222222_256x240.png',
  'css/ui-lightness/images/ui-bg_glass_65_ffffff_1x400.png',
  'css/ui-lightness/jquery-ui-1.10.1.custom.css',
  'css/ui-lightness/jquery-ui-1.10.1.custom.min.css',
  'css/icons.css',
  'css/components.css',
  'css/images/treeview-black-line.gif',
  'css/images/treeview-red.gif',
  'css/images/file.gif',
  'css/images/treeview-red-line.gif',
  'css/images/treeview-default-line.gif',
  'css/images/plus.gif',
  'css/images/treeview-gray-line.gif',
  'css/images/folder.gif',
  'css/images/treeview-famfamfam-line.gif',
  'css/images/minus.gif',
  'css/images/folder-closed.gif',
  'css/images/treeview-default.gif',
  'css/images/treeview-black.gif',
  'css/images/treeview-gray.gif',
  'css/images/treeview-famfamfam.gif',
  'img/icons.png',
  'img/icon_128.png',
  'favicon.ico',
  'manifest.json',
  'index.html',
  './'
];

const CACHE_PREFIX = 'espruino-web-ide-';
const CACHE_NAME = CACHE_PREFIX + VERSION;

self.addEventListener('install', function(event) {
  event.waitUntil(
    caches.open(CACHE_NAME).then(function(cache) {
      return cache.addAll(CACHED_RESOURCES);
    })
  );
});

// Use the cache, fallback to network
self.addEventListener('fetch', function(event) {
  event.respondWith(
    caches.match(event.request, {ignoreSearch: true}).then(function(response) {
      return response || fetch(event.request);
    })
  );
});

// Delete old caches when we change VERSION
self.addEventListener('activate', function(event) {
  event.waitUntil(
    caches.keys().then(function(cacheNames) {
      return Promise.all(
        cacheNames.map(function(cacheName) {
          if (cacheName.startsWith(CACHE_PREFIX) && CACHE_NAME !== cacheName) {
            return caches.delete(cacheName);
          }
        })
      );
    })
  );
});